<?php
DEFINE('JS_TEST', 'js/token.js');
DEFINE('JS', 'js/token-prod.js');
DEFINE('API_TEST', 'https://test-api.centralpay.net/v2/rest/');
DEFINE('API', 'https://api.centralpay.net/v2/rest/');

class Centralpay_Custompaymentmethod_PaymentController extends Mage_Core_Controller_Front_Action {

  protected $_canUseInternal = TRUE;

  protected $_canUseCheckout = TRUE;

  protected $_canUseForMultishipping = TRUE;

  /**
   * Get one page checkout model
   *
   * @return Mage_Checkout_Model_Type_Onepage
   */
  public function getOnepage() {
    return Mage::getSingleton('checkout/type_onepage');
  }

  public function centralpayAction() {


    //   $quote = Mage::getModel('checkout/cart')->getQuote();

    $quote = Mage::getSingleton('checkout/session')->getQuote();
    $quote->assignCustomer(Mage::getSingleton('customer/session')
      ->getCustomer());

    $quote->collectTotals()
      ->getPayment()->setMethod('custompaymentmethod');

    $convert = Mage::getModel('sales/convert_quote');
    $order = $convert->toOrder($quote);
    $order->save();


    $total = $quote->getGrandTotal();
    $add = $quote->getBillingAddress()->getData();
    $detail_com = $quote->getData();
    //  print_r($detail_com);
    //  print_r($_REQUEST);
    //  print_r($add);
    $config = Mage::getStoreConfig('payment/centralpay');
    $customerValidationValue = Mage::app()->getRequest()->getParam('CVV');
    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }


    /*
            $convertQuote = Mage::getSingleton('sales/convert_quote');
    //var_dump($quote->collectTotals()->getPayment());
            $allPaymentMethods = Mage::getModel('payment/config')->getActiveMethods();

            foreach($allPaymentMethods as $paymentMethod) {
                // echo '*'.$paymentMethod->getCode().'<br>';
            }
            $quote = Mage::getSingleton('checkout/session')->getQuote();

            $paymentMethod =    array(
                'method' => 'custompaymentmethod'
            );

            $payment = $quote->getPayment();
            $payment->importData($paymentMethod);
            $payment->setMethod($payment->getMethod());
            $quote->setPayment($payment);
            $quote->collectTotals()->save();

            $order = $convertQuote->toOrder($quote);
    echo $convertQuote->getPayment()->getMethodInstance()->getCode();

                $order->save();

            exit();*/

    /**
     * On vérifie si le compte client actuel est lié à un customer
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');
    $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_customer') . ' WHERE cmsCustomerId=' . intval($detail_com["customer_id"]);
    //  echo $query;
    $results = $readConnection->fetchAll($query);
    if (isset($results[0])) {

      /**
       * Mise à jour du customer
       */
      //   print_r($detail_com);
      // $country = new Country($address->id_country);
      $customerid = $results[0]["customerId"];
      $cust["merchantCustomerId"] = $detail_com["customer_id"];
      $cust["firstName"] = $detail_com["customer_firstname"];
      $cust["lastName"] = $detail_com["customer_lastname"];
      $cust["adressLine1"] = $add["street"];
      $cust["postalCode"] = $add["postcode"];
      $cust["city"] = $add["city"];
      $cust["country"] = $add["country_id"];
      $cust["email"] = $add["email"];
      $cust["phone"] = $add["telephone"];

      $custfields = isset($cust) ? http_build_query($cust) : FALSE;


      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

      $result = curl_exec($curl);
      $info = curl_getinfo($curl);

      /**
       * Enregistrement de la carte via l'api Centralpay
       */

      $cust["cardTokenId"] = Mage::app()->getRequest()->getParam('cardTokenId');
      $cust["customerId"] = $customerid;
      $custfields = isset($cust) ? http_build_query($cust) : FALSE;

      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "card/");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);

      if (isset($retour["errors"])) { // Error message

        $hasError = TRUE;
        $txtError = 'Error enregistrement carte';
      }
      else {


        $card = json_decode($result, 1);

        /**
         * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
         */
        if (Mage::app()->getRequest()->getParam('saveCard') == 1) {

          $table = $resource->getTableName('centralpay_card');
          $query = "INSERT INTO {$table} (`cardId`,`customerId`,`commercialBrand`,`first6`,`last4`,`default`,`cardTokenId`,`expirationYear`,`expirationMonth`)
                    VALUES ('" . addslashes($card["cardId"]) . "'
                    ,'" . addslashes($customerid) . "'
                    ,'" . addslashes($card["commercialBrand"]) . "'
                    ,'" . addslashes($card["first6"]) . "'
                    ,'" . addslashes($card["last4"]) . "'
                    ,1
                      ,'" . addslashes($card["cardTokenId"]) . "'
                        ,'" . addslashes($card["expirationYear"]) . "'
                          ,'" . addslashes($card["expirationMonth"]) . "'
                    )";

          $readConnection->query($query);


        }
        $cardId = $card["cardId"];

      }

    }
    else {
      //            /**
      //             * Si aucun customer n'est rattaché au client actuel on crée le customer
      //             */
      //
      //
      $cust["cardTokenId"] = Mage::app()->getRequest()->getParam('cardTokenId');
      $cust["merchantCustomerId"] = $detail_com["customer_id"];
      $cust["firstName"] = $detail_com["customer_firstname"];
      $cust["lastName"] = $detail_com["customer_lastname"];
      $cust["adressLine1"] = $add["street"];
      $cust["postalCode"] = $add["postcode"];
      $cust["city"] = $add["city"];
      $cust["country"] = $add["country_id"];
      $cust["email"] = $add["email"];
      $cust["phone"] = $add["telephone"];
      // $cust["description"] = '';
      // $cust["additionalDate"] = '';
      $custfields = isset($cust) ? http_build_query($cust) : FALSE;


      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

      $result = curl_exec($curl);
      $info = curl_getinfo($curl);


      $retour = json_decode($result, 1);

      if (isset($retour["errors"])) { /// Error message
        curl_close($curl);
        $hasError = TRUE;
        $txtError = 'Error enregistrement customer';
      }
      else {

        $customer = json_decode($result, 1);
        $customerid = $customer["customerId"];
        /**
         * Enregistrement du lien en le client prestashop et le customer centralpay
         */
        $table = $resource->getTableName('centralpay_customer');
        $query = "INSERT INTO {$table} (`customerId`,`cmsCustomerId`) VALUES ('" . addslashes($customer["customerId"]) . "'," . $detail_com["customer_id"] . ")";

        $readConnection->query($query);

        /**
         * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
         */
        if (Mage::app()->getRequest()->getParam('saveCard') == 1) {

          $table = $resource->getTableName('centralpay_card');
          $query = "INSERT INTO {$table} (`cardId`,`customerId`,`commercialBrand`,`first6`,`last4`,`default`,`cardTokenId`,`expirationYear`,`expirationMonth`)
                    VALUES ('" . addslashes($customer["cards"][0]["cardId"]) . "'
                    ,'" . addslashes($customer["customerId"]) . "'
                    ,'" . addslashes($customer["cards"][0]["commercialBrand"]) . "'
                    ,'" . addslashes($customer["cards"][0]["first6"]) . "'
                    ,'" . addslashes($customer["cards"][0]["last4"]) . "'
                    ,1
                      ,'" . addslashes($customer["cards"][0]["cardTokenId"]) . "'
                        ,'" . addslashes($customer["cards"][0]["expirationYear"]) . "'
                          ,'" . addslashes($customer["cards"][0]["expirationMonth"]) . "'
                    )";

          $readConnection->query($query);


        }
        $cardId = $customer["cards"][0]["cardId"];

      }


    }

    // print_r($config);

    /**
     * Si paiement configuré pour le 3DS
     */
    if (!$hasError && $config["treeds"] == 1) {

      if (isset($_SERVER['HTTPS']) &&
        ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) ||
        isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&
        $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https'
      ) {
        $protocol = 'https://';
      }
      else {
        $protocol = 'http://';
      }


      $enrolement['merchantTransactionIdentifier'] = $quote->getId();
      $enrolement['merchantName'] = $detail_com["store_currency_code"];
      $enrolement['merchantCountry'] = $config["merchant_contry"];
      $enrolement['merchantURL'] = $protocol . $_SERVER["HTTP_HOST"];
      $enrolement['currency'] = $detail_com["store_currency_code"];
      $enrolement['amount'] = intval(Mage::app()
        ->getRequest()
        ->getParam('amount'));
      $enrolement['cardId'] = $cardId;
      $enrolement['customerId'] = $customerid;

      //  var_dump($enrolement);
      $enrolementfields = isset($enrolement) ? http_build_query($enrolement) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "checkEnrollment");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $enrolementfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);


      //erreur sur le retour de l'appel à l'api
      if ($info["http_code"] != 200 || (isset($retour["statuts"]) && $retour["statuts"] == 'FAILURE')) {
        $order->sendNewOrderEmail();
        $order->addStatusHistoryComment('Bank Status : Declined By Bank');
        $order->setIsCustomerNotified(FALSE);
        $order->save();
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', ['_secure' => TRUE]);

        exit();

      }
      Mage::getModel('core/cookie')->set('retour3DS', $result);
      Mage::getModel('core/cookie')->set('cardId', $cardId);
      Mage::getModel('core/cookie')
        ->set('customerValidationValue', $customerValidationValue);
      $url = Mage::getUrl('custompaymentmethod/payment/threedsiframe', ['_secure' => FALSE]);
      Mage::register('redirect_url', $url);
      return $this->_redirectUrl($url);


      exit();

    }
    /**
     * Création de la transaction
     */


    if (!$hasError) {

      $iso_code = substr(Mage::app()->getLocale()->getLocaleCode(),0,2);
      $trans['currency'] = $detail_com["store_currency_code"];
      $trans['amount'] = intval(Mage::app()->getRequest()->getParam('amount'));
      $trans['customerId'] = $customerid;
      $trans['cardId'] = $cardId;
      $trans['merchantTransactionId'] = $quote->getId();
      $trans['endUserLanguage']=$iso_code;
      // $trans['customerValidationValue'] = $customerValidationValue;
      $trans['pointOfSaleId'] = $config["point_of_sale"];
      $trans['endUserIp'] = $adresse_ip;


      $transfields = isset($trans) ? http_build_query($trans) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "transaction");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);


      /**
       * Vérification de l'état de la transaction
       */

      if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {


        //transaction ok
        //on transforme le panier en commande validée et payée
        $order->sendNewOrderEmail();

        $order->addStatusHistoryComment('Bank Status : ----');

        $order->setIsCustomerNotified(FALSE);

        $order->save();
        $comment = $order->sendNewOrderEmail()
          ->addStatusHistoryComment('Bank Status : ----')
          ->setIsCustomerNotified(FALSE)
          ->save();

        $payment = $order->getPayment();
        $grandTotal = $order->getBaseGrandTotal();
        if (isset($retour["transactionId"])) {
          $tid = $retour["transactionId"];
        }
        else {
          $tid = -1;
        }

        $payment->setTransactionId($tid)
          ->setPreparedMessage("Payment Sucessfull Result:")
          ->setIsTransactionClosed(0)
          ->registerAuthorizationNotification($grandTotal);
        $order->save();

        try {
          if (!$order->canInvoice()) {
            Mage::throwException(Mage::helper('core')
              ->__('Cannot create an invoice.'));
          }

          $invoice = Mage::getModel('sales/service_order', $order)
            ->prepareInvoice();

          if (!$invoice->getTotalQty()) {
            Mage::throwException(Mage::helper('core')
              ->__('Cannot create an invoice without products.'));
          }

          $invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_ONLINE);
          //Or you can use
          //$invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_OFFLINE);
          $invoice->register();
          $transactionSave = Mage::getModel('core/resource_transaction')
            ->addObject($invoice)
            ->addObject($invoice->getOrder());

          $transactionSave->save();
          $message = Mage::helper('pay')
            ->__('Notified customer about invoice #%s.', $invoice->getIncrementId());
          $comment = $order->sendNewOrderEmail()
            ->addStatusHistoryComment($message)
            ->setIsCustomerNotified(TRUE)
            ->save();

        } catch (Mage_Core_Exception $e) {
          var_dump($e);
        }


        //                $cart = new Cart((int)$panier->id);
        //                $order_status = (int)Configuration::get('PS_OS_PAYMENT');
        //                $order_total = $cart->getOrderTotal(true, Cart::BOTH);
        //                $this->module->validateOrder($panier->id, $order_status, $order_total, $this->module->l('Credit/Debit card', $this->module->name), null, array('transaction_id' => $retour["transactionId"]), null, false, $panier->secure_key);
        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        //                $orderid = Order::getOrderByCartId((int)($cart->id));
        //
        //                $order = new Order($orderid);
        //
        //                $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'order_payment WHERE order_reference=\'' . pSQL($order->reference) . '\'';
        //                $results = Db::getInstance()->ExecuteS($sql);
        //                if (is_array($results)) {
        //                    foreach ($results as $r) {
        //                        if ($r["transaction_id"] == $retour["transactionId"]) {
        //                            /**
        //                             * Enregistrement du lient entre la carte et le paiement Prestashop si la carte a été sauvegardée
        //                             */
        //                            if (Mage::app()->getRequest()->getParam('saveCard') == 1) {
        //
        //                                $table = $resource->getTableName('centralpay_payment_card');
        //                                $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`) VALUES ('" . addslashes($cardId) . "'," . $detail_com["customer_id"] . ")";
        //
        //                                $readConnection->query($query);
        //
        //
        //                                Db::getInstance()->insert('centralpay_payment_card', array(
        //                                    'cardId' => pSQL($cardId),
        //                                    'cmsPaymentId' => pSQL($r["id_order_payment"])));
        //                            }
        //
        //                        }
        //
        //
        //                    }
        //
        //
        //                }
        $order->sendNewOrderEmail();
        $order->addStatusHistoryComment('Bank Status : Declined By Bank');
        $order->setIsCustomerNotified(FALSE);
        $order->save();
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', ['_secure' => TRUE]);

        /* $url = Mage::getUrl('checkout/onepage/success', array('_secure'=>true));
         Mage::register('redirect_url',$url);
         $this->_redirectUrl($url);*/


      }
      elseif (isset($info["http_code"]) && $info["http_code"] == 307) {
        $retour = json_decode($result, 1);
        if (is_array($retour["checkEnrollment"])) {
          Mage::getModel('core/cookie')
            ->set('retour3DS', json_encode($retour["checkEnrollment"]));
          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('saveCard', Tools::getValue("saveCard"));
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          if (isset($retour["otp"]) && $retour["otp"]) {
            Mage::getModel('core/cookie')->set('otp', 1);

          }
          if (isset($retour["cvc"]) && $retour["cvc"]) {
            Mage::getModel('core/cookie')->set('cvc', 1);

          }
          $url = Mage::getUrl('custompaymentmethod/payment/threedsiframe', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);
          exit();

        }
        if (isset($retour["otp"]) && $retour["otp"]) {

          if (isset($retour["cvc"]) && $retour["cvc"]) {
            Mage::getModel('core/cookie')->set('cvc', 1);

          }

          $otp['customerId'] = $customerid;
          $otp['provider'] = $config["provider"];
          $otp['currency'] = $detail_com["store_currency_code"];
          $otp['amount'] = $total;
          $otpfields = isset($otp) ? http_build_query($otp) : FALSE;
          $curl = curl_init();
          curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
          curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
          curl_setopt($curl, CURLOPT_POST, 1);
          curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
          curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
          $result = curl_exec($curl);
          $info = curl_getinfo($curl);
          $retour = json_decode($result, 1);
          curl_close($curl);

          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('saveCard', Tools::getValue("saveCard"));
          $url = Mage::getUrl('custompaymentmethod/payment/otp', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);
          exit();


        }
        if (isset($retour["cvc"]) && $retour["cvc"]) {
          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('saveCard', Tools::getValue("saveCard"));
          $url = Mage::getUrl('custompaymentmethod/payment/cvc', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);
          exit();
        }


      }
      else {
        $order->sendNewOrderEmail();
        $order->addStatusHistoryComment('Bank Status : Declined By Bank');
        $order->setIsCustomerNotified(FALSE);
        $order->save();
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/error', ['_secure' => FALSE]);

      }


      if (isset($retour["errors"])) {  // Error message
        $order->sendNewOrderEmail();
        $order->addStatusHistoryComment('Bank Status : Declined By Bank');
        $order->setIsCustomerNotified(FALSE);
        $order->save();
        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/error', ['_secure' => FALSE]);

      }

    }
    else {
      $order->sendNewOrderEmail();
      $order->addStatusHistoryComment('Bank Status : Declined By Bank');
      $order->setIsCustomerNotified(FALSE);
      $order->save();
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/error', ['_secure' => FALSE]);


      /*  $this->_forward('error');*/
    }

    //  print_r($_REQUEST);

    exit();

    if ($this->getRequest()->get("orderId")) {
      $arr_querystring = [
        'flag' => 1,
        'orderId' => $this->getRequest()->get("orderId"),
      ];

      Mage_Core_Controller_Varien_Action::_redirect('custompaymentmethod/payment/response', [
        '_secure' => FALSE,
        '_query' => $arr_querystring,
      ]);
    }
  }

  public function savePaymentAction() {
    try {
      if (!$this->getRequest()->isPost()) {
        Mage::getSingleton('checkout/type_onepage')->_ajaxRedirectResponse();
        return;
      }

      $data = $this->getRequest()->getPost('payment', []);

      // enregistrement du token en session
      Mage::getSingleton('core/session')->setData('tokenid', $this->getRequest()
        ->getPost('cardTokenId'));
      Mage::getSingleton('core/session')
        ->setData('saveCard', $this->getRequest()->getPost('saveCard'));
      Mage::getSingleton('core/session')->setData('card', $this->getRequest()
        ->getPost('card'));
      Mage::getSingleton('core/session')->setData('cvcForce', $this->getRequest()
        ->getPost('cvcForce'));
      Mage::getSingleton('core/session')->setData('cardId', $this->getRequest()
        ->getPost('cardId'));
      Mage::getSingleton('core/session')
        ->setData('customerValidationValue', $this->getRequest()
          ->getPost('customerValidationValue'));
      $ype_one_page = Mage::getSingleton('checkout/type_onepage');
      $result = $ype_one_page->savePayment($data);

      // get section and redirect data
      $redirectUrl = $ype_one_page->getQuote()
        ->getPayment()
        ->getCheckoutRedirectUrl();

      if (empty($result['error']) && !$redirectUrl) {
        $this->loadLayout('checkout_onepage_review');

        $result['goto_section'] = 'review';
        $result['update_section'] = [
          'name' => 'review',
          'html' => $this->getLayout()->getBlock('root')->toHtml(),
        ];
      }
      if ($redirectUrl) {
        $result['redirect'] = $redirectUrl;
      }
    } catch (Mage_Payment_Exception $e) {
      if ($e->getFields()) {
        $result['fields'] = $e->getFields();
      }
      $result['error'] = $e->getMessage();
    } catch (Mage_Core_Exception $e) {
      $result['error'] = $e->getMessage();
    } catch (Exception $e) {

      Mage::logException($e);
      $result['error'] = $this->__('Unable to set Payment Method.');
    }
    $this->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
  }

  public function savePaymentMultishippingAction() {
    // Url erreur de paiement
    $url_error = Mage::getUrl('checkout/multishipping/billing', ['_secure' => FALSE]);
    try {


      $payment = $this->getRequest()->getPost('payment', []);


      $data = $this->getRequest()->getPost('payment', []);

      // enregistrement du token en session
      Mage::getSingleton('core/session')->setData('tokenid', $this->getRequest()
        ->getPost('cardTokenId'));
      Mage::getSingleton('core/session')
        ->setData('saveCard', $this->getRequest()->getPost('saveCard'));
      Mage::getSingleton('core/session')->setData('card', $this->getRequest()
        ->getPost('card'));
      Mage::getSingleton('core/session')->setData('cvcForce', $this->getRequest()
        ->getPost('cvcForce'));
      Mage::getSingleton('core/session')->setData('cardId', $this->getRequest()
        ->getPost('cardId'));
      Mage::getSingleton('core/session')
        ->setData('customerValidationValue', $this->getRequest()
          ->getPost('customerValidationValue'));
      Mage::getSingleton('core/session')->setData('payment', $payment);
      $ype_one_page = Mage::getSingleton('checkout/type_onepage');
      $result = $ype_one_page->savePayment($data);

      // get section and redirect data
      $redirectUrl = $ype_one_page->getQuote()
        ->getPayment()
        ->getCheckoutRedirectUrl();

      if (empty($result['error']) && !$redirectUrl) {
        $this->loadLayout('checkout_onepage_review');

        $result['goto_section'] = 'review';
        $result['update_section'] = [
          'name' => 'review',
          'html' => $this->getLayout()->getBlock('root')->toHtml(),
        ];
      }
      if ($redirectUrl) {
        $result['redirect'] = $redirectUrl;
      }
    } catch (Mage_Payment_Exception $e) {
      if ($e->getFields()) {
        $result['fields'] = $e->getFields();
      }
      $result['error'] = $e->getMessage();
      return $this->_redirectUrl($url_error);
      exit();
    } catch (Mage_Core_Exception $e) {
      $result['error'] = $e->getMessage();
      return $this->_redirectUrl($url_error);
      exit();
    } catch (Exception $e) {

      Mage::logException($e);
      $result['error'] = $this->__('Unable to set Payment Method.');
      return $this->_redirectUrl($url_error);
      exit();
    }
    $url_suite = Mage::getUrl('custompaymentmethod/payment/postmultishiping/', ['_secure' => TRUE]);
    return $this->getResponse()->setRedirect($url_suite);
    exit();
  }

  public function postMultishipingAction() {
    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_3ds_centralpay',
      ['template' => 'centralpay/postmultishipping.phtml']
    );

    $this->getLayout()->getBlock('content')->append($block);


    $this->renderLayout();

  }

  public function redirectAction() {

    $this->initialiseCookieSession();
    $useCard = FALSE;

    // Url erreur de paiement
    $url_error = Mage::getUrl('custompaymentmethod/payment/error', ['_secure' => FALSE]);


    $onepage = Mage::getSingleton('checkout/type_onepage');
    $session = $onepage->getCheckout();
    if (!$session->getLastSuccessQuoteId()) {
      $this->_redirect('checkout/cart');
      return;
    }

    $lastQuoteId = $session->getLastQuoteId();
    $lastOrderId = $session->getLastOrderId();


    $order = Mage::getModel('sales/order')->loadByIncrementId($lastOrderId);
    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);

    $total = intval($quote->getGrandTotal() * 100);


    $add = $quote->getBillingAddress()->getData();
    $detail_com = $quote->getData();
    //  print_r($detail_com);
    //  print_r($_REQUEST);
    //  print_r($add);
    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }

    /*
     * On vérifie si le client utilise une carte enregistrée
     */
    if (trim(Mage::getSingleton('core/session')->getData('cardId')) != '') {


      $resource = Mage::getSingleton('core/resource');
      $readConnection = $resource->getConnection('core_read');
      $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_card') . ' as A INNER JOIN ' . $resource->getTableName('centralpay_customer') . ' as B  ON A.customerId=B.customerId WHERE A.cardId=\'' . addslashes(Mage::getSingleton('core/session')
          ->getData('cardId')) . '\' AND B.cmsCustomerId=' . intval($detail_com["customer_id"]);


      $results = $readConnection->fetchAll($query);
      $customerid = $results[0]["customerId"];
      $cardId = Mage::getSingleton('core/session')->getData('cardId');

      $useCard = TRUE;


    }


    /**
     * Token
     */
    $token = Mage::getSingleton('core/session')->getData('tokenid');


    if (!$useCard) {
      /**
       * On vérifie si le compte client actuel est lié à un customer
       */
      $resource = Mage::getSingleton('core/resource');
      $readConnection = $resource->getConnection('core_read');
      $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_customer') . ' WHERE cmsCustomerId=' . intval($detail_com["customer_id"]);

      $results = $readConnection->fetchAll($query);

      if (isset($results[0])) {

        /**
         * Mise à jour du customer
         */
        //   print_r($detail_com);
        // $country = new Country($address->id_country);
        $customerid = $results[0]["customerId"];
        $cust["merchantCustomerId"] = $detail_com["customer_id"];
        $cust["firstName"] = $detail_com["customer_firstname"];
        $cust["lastName"] = $detail_com["customer_lastname"];
        $cust["adressLine1"] = $add["street"];
        $cust["postalCode"] = $add["postcode"];
        $cust["city"] = $add["city"];
        $cust["country"] = $add["country_id"];
        $cust["email"] = $add["email"];
        $cust["phone"] = $add["telephone"];
        $custfields = isset($cust) ? http_build_query($cust) : FALSE;


        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

        $result = curl_exec($curl);

        $info = curl_getinfo($curl);

        /**
         * Enregistrement de la carte via l'api Centralpay
         */

        $cust["cardTokenId"] = $token;
        $cust["customerId"] = $customerid;
        $custfields = isset($cust) ? http_build_query($cust) : FALSE;

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, trim($url_api) . "card/");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
        $result = curl_exec($curl);
        $info = curl_getinfo($curl);
        $retour = json_decode($result, 1);

        curl_close($curl);

        if ($info["http_code"] != 200 || isset($retour["errors"])) { // Error message

          $hasError = TRUE;
          $txtError = 'Error enregistrement carte';
        }
        else {


          $card = json_decode($result, 1);

          /**
           * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
           */
          if (Mage::getSingleton('core/session')->getData('saveCard') == 1) {

            $table = $resource->getTableName('centralpay_card');

            $query = "UPDATE {$table} SET `default`=0 WHERE customerId='" . addslashes($customerid) . "'";
            $readConnection->query($query);

            $query = "INSERT INTO {$table} (`cardId`,`customerId`,`commercialBrand`,`first6`,`last4`,`default`,`cardTokenId`,`expirationYear`,`expirationMonth`)
                    VALUES ('" . addslashes($card["cardId"]) . "'
                    ,'" . addslashes($customerid) . "'
                    ,'" . addslashes($card["commercialBrand"]) . "'
                    ,'" . addslashes($card["first6"]) . "'
                    ,'" . addslashes($card["last4"]) . "'
                    ,1
                      ,'" . addslashes($card["cardTokenId"]) . "'
                        ,'" . addslashes($card["expirationYear"]) . "'
                          ,'" . addslashes($card["expirationMonth"]) . "'
                    )";

            $readConnection->query($query);


          }
          $cardId = $card["cardId"];


        }

      }
      else {
        //            /**
        //             * Si aucun customer n'est rattaché au client actuel on crée le customer
        //             */
        //
        //

        $cust["cardTokenId"] = $token;
        $cust["merchantCustomerId"] = $detail_com["customer_id"];
        $cust["firstName"] = $detail_com["customer_firstname"];
        $cust["lastName"] = $detail_com["customer_lastname"];
        $cust["adressLine1"] = $add["street"];
        $cust["postalCode"] = $add["postcode"];
        $cust["city"] = $add["city"];
        $cust["country"] = $add["country_id"];
        $cust["email"] = $add["email"];
        $cust["phone"] = $add["telephone"];
        $custfields = isset($cust) ? http_build_query($cust) : FALSE;


        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

        $result = curl_exec($curl);
        $info = curl_getinfo($curl);


        $retour = json_decode($result, 1);

        if ($info["http_code"] != 200 || isset($retour["errors"])) { /// Error message
          curl_close($curl);
          $hasError = TRUE;
          $txtError = 'Error enregistrement customer';
        }
        else {

          $customer = json_decode($result, 1);
          $customerid = $customer["customerId"];
          /**
           * Enregistrement du lien en le client prestashop et le customer centralpay
           */
          $table = $resource->getTableName('centralpay_customer');
          $query = "INSERT INTO {$table} (`customerId`,`cmsCustomerId`) VALUES ('" . addslashes($customer["customerId"]) . "'," . $detail_com["customer_id"] . ")";

          $readConnection->query($query);

          /**
           * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
           */
          if (Mage::getSingleton('core/session')->getData('saveCard') == 1) {


            $table = $resource->getTableName('centralpay_card');

            $query = "UPDATE {$table} SET `default`=0 WHERE customerId='" . addslashes($customer["customerId"]) . "'";
            $readConnection->query($query);

            $query = "INSERT INTO {$table} (`cardId`,`customerId`,`commercialBrand`,`first6`,`last4`,`default`,`cardTokenId`,`expirationYear`,`expirationMonth`)
                    VALUES ('" . addslashes($customer["cards"][0]["cardId"]) . "'
                    ,'" . addslashes($customer["customerId"]) . "'
                    ,'" . addslashes($customer["cards"][0]["commercialBrand"]) . "'
                    ,'" . addslashes($customer["cards"][0]["first6"]) . "'
                    ,'" . addslashes($customer["cards"][0]["last4"]) . "'
                    ,1
                      ,'" . addslashes($customer["cards"][0]["cardTokenId"]) . "'
                        ,'" . addslashes($customer["cards"][0]["expirationYear"]) . "'
                          ,'" . addslashes($customer["cards"][0]["expirationMonth"]) . "'
                    )";

            $readConnection->query($query);


          }
          $cardId = $customer["cards"][0]["cardId"];

        }


      }

    }

    /**
     * Si paiement configuré pour le 3DS
     */
    if (!$hasError && $config["treeds"] == 1) {

      if (isset($_SERVER['HTTPS']) &&
        ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) ||
        isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&
        $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https'
      ) {
        $protocol = 'https://';
      }
      else {
        $protocol = 'http://';
      }

      $enrolement['merchantTransactionIdentifier'] = $quote->getId();
      $enrolement['merchantName'] = $detail_com["store_currency_code"];
      $enrolement['merchantCountry'] = $config["merchant_contry"];
      $enrolement['merchantURL'] = $protocol . $_SERVER["HTTP_HOST"];
      $enrolement['currency'] = $detail_com["store_currency_code"];
      $enrolement['amount'] = $total;
      $enrolement['cardId'] = $cardId;
      $enrolement['customerId'] = $customerid;

      $enrolementfields = isset($enrolement) ? http_build_query($enrolement) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "checkEnrollment");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $enrolementfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);


      //erreur sur le retour de l'appel à l'api
      if ($info["http_code"] != 200 || (isset($retour["statuts"]) && $retour["statuts"] == 'FAILURE')) {
        return $this->_redirectUrl($url_error);
        exit();

      }
      Mage::getModel('core/cookie')->set('retour3DS', $result);
      Mage::getModel('core/cookie')->set('cardId', $cardId);
      Mage::getModel('core/cookie')
        ->set('orderId', $session->getLastRealOrderId());
      Mage::getModel('core/cookie')
        ->set('customerValidationValue', $customerValidationValue);
      $url = Mage::getUrl('custompaymentmethod/payment/threedsiframe', ['_secure' => FALSE]);
      Mage::register('redirect_url', $url);
      return $this->_redirectUrl($url);


      exit();

    }


    /**
     * Création de la transaction
     */


    if (!$hasError) {

      $iso_code = substr(Mage::app()->getLocale()->getLocaleCode(),0,2);
      $trans['currency'] = $detail_com["store_currency_code"];
      $trans['amount'] = $total;
      $trans['customerId'] = $customerid;
      $trans['cardId'] = $cardId;
      $trans['merchantTransactionId'] = $quote->getId();
      $trans['endUserLanguage']=$iso_code;
      //   $trans['customerValidationValue'] = $customerValidationValue;
      $trans['pointOfSaleId'] = $config["point_of_sale"];
      $trans['endUserIp'] = $adresse_ip;


       if($useCard && $config["forcecvc"]==1){
        $cvc =  Mage::getSingleton('core/session')->getData('cvcForce');
        if(trim($cvc)!='') {
          $trans["cvcValidation"] = $cvc;
        }
      }

      Mage::getModel('core/cookie')
        ->set('transaction', json_encode($trans));

      $transfields = isset($trans) ? http_build_query($trans) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "transaction");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);


      /**
       * Vérification de l'état de la transaction
       */


      if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {


        $order = Mage::getModel('sales/order');
        $order->loadByIncrementId($session->getLastRealOrderId());
        $OrderId = $order->getId();
        $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
          'Payment success'
        );

        $payment = $order->getPayment();
        $payment->setTransactionId($retour["transactionId"])
          ->setCurrencyCode($order->getBaseCurrencyCode())
          ->setPreparedMessage('Payment by Centralpay')
          //  ->setParentTransactionId($retour["transactionId"])
          ->setShouldCloseParentTransaction(TRUE)
          ->setIsTransactionClosed(1)
          ->registerCaptureNotification($total / 100);
        $order->save();

        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        $table = $resource->getTableName('centralpay_payment_card');
        $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes($cardId) . "'
                    ,'" . addslashes($OrderId) . "')";
        $readConnection->query($query);


        $this->emptyCookieSession();

        Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', ['_secure' => FALSE]);


      }
      elseif (isset($info["http_code"]) && $info["http_code"] == 307) {
        $retour = json_decode($result, 1);
        if (is_array($retour["checkEnrollment"])) {
          Mage::getModel('core/cookie')
            ->set('retour3DS', json_encode($retour["checkEnrollment"]));
          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('saveCard', Mage::getSingleton('core/session')
              ->getData('saveCard'));
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('orderId', $session->getLastRealOrderId());
          if (isset($retour["otp"]) && $retour["otp"]) {
            Mage::getModel('core/cookie')->set('otp', 1);

          }else{
            Mage::getModel('core/cookie')->set('otp', 0);
          }
          if (isset($retour["cvc"]) && $retour["cvc"]) {
            Mage::getModel('core/cookie')->set('cvc', 1);

          }else{
            Mage::getModel('core/cookie')->set('cvc', 0);
          }
          $url = Mage::getUrl('custompaymentmethod/payment/threedsiframe', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);


          exit();

        }
        if (isset($retour["otp"]) && $retour["otp"]) {
          if (isset($retour["cvc"]) && $retour["cvc"]) {
            Mage::getModel('core/cookie')->set('cvc', 1);

          }else{
            Mage::getModel('core/cookie')->set('cvc', 0);
          }

          $otp['customerId'] = $customerid;
          $otp['provider'] = $config["provider"];
          $otp['currency'] = $detail_com["store_currency_code"];
          $otp['amount'] = $total;
          $otpfields = isset($otp) ? http_build_query($otp) : FALSE;
          $curl = curl_init();
          curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
          curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
          curl_setopt($curl, CURLOPT_POST, 1);
          curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
          curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
          $result = curl_exec($curl);
          $info = curl_getinfo($curl);
          $retour = json_decode($result, 1);
          curl_close($curl);

          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('orderId', $session->getLastRealOrderId());
          Mage::getModel('core/cookie')
            ->set('otp', 1);
          Mage::getModel('core/cookie')
            ->set('saveCard', Mage::getSingleton('core/session')
              ->getData('saveCard'));


          $url = Mage::getUrl('custompaymentmethod/payment/otp', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);


          exit();


        }

        if (isset($retour["cvc"]) && $retour["cvc"]) {
          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('orderId', $session->getLastRealOrderId());
          Mage::getModel('core/cookie')
            ->set('saveCard', Mage::getSingleton('core/session')
              ->getData('saveCard'));
          $url = Mage::getUrl('custompaymentmethod/payment/cvc', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);
          exit();
        }

      }
      else {

        $this->emptyCookieSession();
        return $this->_redirectUrl($url_error);

      }


      if (isset($retour["errors"])) {  // Error message
        $this->emptyCookieSession();
        return $this->_redirectUrl($url_error);

      }

    }
    else {
      $this->emptyCookieSession();
      return $this->_redirectUrl($url_error);
    }

  }

  public function emptyCookieSession() {

    Mage::getModel('core/cookie')->delete('retour3DS');
    Mage::getModel('core/cookie')->delete('cardId');
    Mage::getModel('core/cookie')->delete('orderId');
    Mage::getModel('core/cookie')->delete('customerValidationValue');
    Mage::getModel('core/cookie')->delete('otp');
    Mage::getModel('core/cookie')->delete('transaction');
    Mage::getModel('core/cookie')->delete('cvc');
    Mage::getSingleton('core/session')->setData('tokenid', '');
    Mage::getSingleton('core/session')->setData('saveCarte', '');
    Mage::getSingleton('core/session')->setData('card', '');
    Mage::getSingleton('core/session')->setData('cardId', '');
    Mage::getSingleton('core/session')->setData('customerValidationValue', '');
    Mage::getSingleton('core/session')->setData('otp', '');
    Mage::getSingleton('core/session')->setData('transaction', '');
    Mage::getSingleton('core/session')->setData('cvc', '');
  }

  public function initialiseCookieSession() {


    Mage::getModel('core/cookie')->delete('otp');
    Mage::getModel('core/cookie')->delete('transaction');
    Mage::getModel('core/cookie')->delete('cvc');
    Mage::getSingleton('core/session')->setData('otp', '');
    Mage::getSingleton('core/session')->setData('transaction', '');
    Mage::getSingleton('core/session')->setData('cvc', '');
  }


  public function redirectmultishippingAction() {
    $this->initialiseCookieSession();

    $useCard = FALSE;

    // Url erreur de paiement
    $url_error = Mage::getUrl('custompaymentmethod/payment/error', ['_secure' => FALSE]);


    $multishipping = Mage::getSingleton('checkout/type_multishipping');
    $session = $multishipping->getCheckout();

    $lastQuoteId = Mage::getSingleton('checkout/session')->getLastQuoteId();
    $lastOrderId = $multishipping->getLastOrderId();


    $order = Mage::getModel('sales/order')->loadByIncrementId($lastOrderId);
    $quote = $this->_getCheckoutSession()->getQuote();

    $total = intval($quote->getGrandTotal() * 100);


    $detail_com = $quote->getData();


    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];
    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }

    /*
     * On vérifie si le client utilise une carte enregistrée
     */
    if (trim(Mage::getSingleton('core/session')->getData('cardId')) != '') {


      $resource = Mage::getSingleton('core/resource');
      $readConnection = $resource->getConnection('core_read');
      $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_card') . ' as A INNER JOIN ' . $resource->getTableName('centralpay_customer') . ' as B  ON A.customerId=B.customerId WHERE A.cardId=\'' . addslashes(Mage::getSingleton('core/session')
          ->getData('cardId')) . '\' AND B.cmsCustomerId=' . intval($detail_com["customer_id"]);


      $results = $readConnection->fetchAll($query);
      $customerid = $results[0]["customerId"];
      $cardId = Mage::getSingleton('core/session')->getData('cardId');

      $useCard = TRUE;


    }


    /**
     * Token
     */
    $token = Mage::getSingleton('core/session')->getData('tokenid');


    if (!$useCard) {
      /**
       * On vérifie si le compte client actuel est lié à un customer
       */
      $resource = Mage::getSingleton('core/resource');
      $readConnection = $resource->getConnection('core_read');
      $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_customer') . ' WHERE cmsCustomerId=' . intval($detail_com["customer_id"]);

      $results = $readConnection->fetchAll($query);
      $add = $quote->getBillingAddress()->getData();
      if (isset($results[0])) {

        /**
         * Mise à jour du customer
         */
        //   print_r($detail_com);
        // $country = new Country($address->id_country);
        $customerid = $results[0]["customerId"];
        $cust["merchantCustomerId"] = $detail_com["customer_id"];
        $cust["firstName"] = $detail_com["customer_firstname"];
        $cust["lastName"] = $detail_com["customer_lastname"];
        $cust["adressLine1"] = $add["street"];

        $cust["postalCode"] = $add["postcode"];
        $cust["city"] = $add["city"];
        $cust["country"] = $add["country_id"];
        $cust["email"] = $add["email"];
        $cust["phone"] = $add["telephone"];
        $custfields = isset($cust) ? http_build_query($cust) : FALSE;


        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

        $result = curl_exec($curl);

        $info = curl_getinfo($curl);

        /**
         * Enregistrement de la carte via l'api Centralpay
         */

        $cust["cardTokenId"] = $token;
        $cust["customerId"] = $customerid;
        $custfields = isset($cust) ? http_build_query($cust) : FALSE;

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, trim($url_api) . "card/");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
        $result = curl_exec($curl);
        $info = curl_getinfo($curl);
        $retour = json_decode($result, 1);
        curl_close($curl);

        if ($info["http_code"] != 200 || isset($retour["errors"])) { // Error message

          $hasError = TRUE;
          $txtError = 'Error enregistrement carte';
        }
        else {


          $card = json_decode($result, 1);

          /**
           * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
           */
          if (Mage::getSingleton('core/session')->getData('saveCard') == 1) {

            $table = $resource->getTableName('centralpay_card');

            $query = "UPDATE {$table} SET `default`=0 WHERE customerId='" . addslashes($customerid) . "'";
            $readConnection->query($query);

            $query = "INSERT INTO {$table} (`cardId`,`customerId`,`commercialBrand`,`first6`,`last4`,`default`,`cardTokenId`,`expirationYear`,`expirationMonth`)
                    VALUES ('" . addslashes($card["cardId"]) . "'
                    ,'" . addslashes($customerid) . "'
                    ,'" . addslashes($card["commercialBrand"]) . "'
                    ,'" . addslashes($card["first6"]) . "'
                    ,'" . addslashes($card["last4"]) . "'
                    ,1
                      ,'" . addslashes($card["cardTokenId"]) . "'
                        ,'" . addslashes($card["expirationYear"]) . "'
                          ,'" . addslashes($card["expirationMonth"]) . "'
                    )";


            $readConnection->query($query);


          }
          $cardId = $card["cardId"];


        }

      }
      else {
        //            /**
        //             * Si aucun customer n'est rattaché au client actuel on crée le customer
        //             */
        //
        //
        $cust["cardTokenId"] = $token;
        $cust["merchantCustomerId"] = $detail_com["customer_id"];
        $cust["firstName"] = $detail_com["customer_firstname"];
        $cust["lastName"] = $detail_com["customer_lastname"];
        $cust["adressLine1"] = $add["street"];

        $cust["postalCode"] = $add["postcode"];
        $cust["city"] = $add["city"];
        $cust["country"] = $add["country_id"];
        $cust["email"] = $add["email"];
        $cust["phone"] = $add["telephone"];

        $custfields = isset($cust) ? http_build_query($cust) : FALSE;


        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

        $result = curl_exec($curl);
        $info = curl_getinfo($curl);


        $retour = json_decode($result, 1);

        if ($info["http_code"] != 200 || isset($retour["errors"])) { /// Error message
          curl_close($curl);
          $hasError = TRUE;
          $txtError = 'Error enregistrement customer';
        }
        else {

          $customer = json_decode($result, 1);
          $customerid = $customer["customerId"];
          /**
           * Enregistrement du lien en le client prestashop et le customer centralpay
           */
          $table = $resource->getTableName('centralpay_customer');
          $query = "INSERT INTO {$table} (`customerId`,`cmsCustomerId`) VALUES ('" . addslashes($customer["customerId"]) . "','" . $detail_com["customer_id"] . "')";

          $readConnection->query($query);

          /**
           * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
           */
          echo Mage::app()->getRequest()->getParam('saveCard');
          if (Mage::getSingleton('core/session')->getData('saveCard') == 1) {


            $table = $resource->getTableName('centralpay_card');

            $query = "UPDATE {$table} SET `default`=0 WHERE customerId='" . addslashes($customer["customerId"]) . "'";
            $readConnection->query($query);

            $query = "INSERT INTO {$table} (`cardId`,`customerId`,`commercialBrand`,`first6`,`last4`,`default`,`cardTokenId`,`expirationYear`,`expirationMonth`)
                    VALUES ('" . addslashes($customer["cards"][0]["cardId"]) . "'
                    ,'" . addslashes($customer["customerId"]) . "'
                    ,'" . addslashes($customer["cards"][0]["commercialBrand"]) . "'
                    ,'" . addslashes($customer["cards"][0]["first6"]) . "'
                    ,'" . addslashes($customer["cards"][0]["last4"]) . "'
                    ,1
                      ,'" . addslashes($customer["cards"][0]["cardTokenId"]) . "'
                        ,'" . addslashes($customer["cards"][0]["expirationYear"]) . "'
                          ,'" . addslashes($customer["cards"][0]["expirationMonth"]) . "'
                    )";

            $readConnection->query($query);


          }
          $cardId = $customer["cards"][0]["cardId"];

        }


      }

    }


    /**
     * Si paiement configuré pour le 3DS
     */
    if (!$hasError && $config["treeds"] == 1) {

      if (isset($_SERVER['HTTPS']) &&
        ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) ||
        isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&
        $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https'
      ) {
        $protocol = 'https://';
      }
      else {
        $protocol = 'http://';
      }

      $enrolement['merchantTransactionIdentifier'] = $quote->getId();
      $enrolement['merchantName'] = $detail_com["store_currency_code"];
      $enrolement['merchantCountry'] = $config["merchant_contry"];
      $enrolement['merchantURL'] = $protocol . $_SERVER["HTTP_HOST"];
      $enrolement['currency'] = $detail_com["store_currency_code"];
      $enrolement['amount'] = $total;
      $enrolement['cardId'] = $cardId;
      $enrolement['customerId'] = $customerid;

      $enrolementfields = isset($enrolement) ? http_build_query($enrolement) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "checkEnrollment");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $enrolementfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);


      //erreur sur le retour de l'appel à l'api
      if ($info["http_code"] != 200 || (isset($retour["statuts"]) && $retour["statuts"] == 'FAILURE')) {
        return $this->_redirectUrl($url_error);
        exit();

      }
      Mage::getModel('core/cookie')->set('retour3DS', $result);
      Mage::getModel('core/cookie')->set('cardId', $cardId);
      Mage::getModel('core/cookie')->set('orderId', $quote->getId());
      Mage::getModel('core/cookie')
        ->set('customerValidationValue', $customerValidationValue);
      $url = Mage::getUrl('custompaymentmethod/payment/threedsiframemultishipping', ['_secure' => FALSE]);
      Mage::register('redirect_url', $url);
      return $this->_redirectUrl($url);


      exit();

    }


    /**
     * Création de la transaction
     */


    if (!$hasError) {

      $iso_code = substr(Mage::app()->getLocale()->getLocaleCode(),0,2);
      $trans['currency'] = $detail_com["store_currency_code"];
      $trans['amount'] = $total;
      $trans['customerId'] = $customerid;
      $trans['cardId'] = $cardId;
      $trans['merchantTransactionId'] = $quote->getId();
      $trans['endUserLanguage']=$iso_code;
      //  $trans['customerValidationValue'] = $customerValidationValue;
      $trans['pointOfSaleId'] = $config["point_of_sale"];
      $trans['endUserIp'] = $adresse_ip;
      if($useCard && $config["forcecvc"]==1){
        $cvc =  Mage::getSingleton('core/session')->getData('cvcForce');
        if(trim($cvc)!='') {
          $trans["cvcValidation"] = $cvc;
        }
      }




      Mage::getModel('core/cookie')
        ->set('transaction', json_encode($trans));

      $transfields = isset($trans) ? http_build_query($trans) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "transaction");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);

      /**
       * Vérification de l'état de la transaction
       */


      if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {


        $this->_getCheckout()->createOrders();
        //  var_dump($this->_getCheckout()->getOrderIds()).'***';

        if (is_array($this->_getCheckout()->getOrderIds())) {
          foreach ($this->_getCheckout()->getOrderIds() as $IdOrder) {

            echo $IdOrder;
            $order = Mage::getModel('sales/order')->load($IdOrder);
            // $order->loadByIncrementId($IdOrder);
            $OrderId = $order->getId();
            $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
              'Payment success'
            );

            $payment = $order->getPayment();
            $payment->setTransactionId($retour["transactionId"])
              ->setCurrencyCode($order->getBaseCurrencyCode())
              ->setPreparedMessage('Payment by Centralpay')
              //  ->setParentTransactionId($retour["transactionId"])
              ->setShouldCloseParentTransaction(TRUE)
              ->setIsTransactionClosed(1)
              ->registerCaptureNotification($total / 100);
            $order->save();


          }

        }


        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        $table = $resource->getTableName('centralpay_payment_card');
        $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes($cardId) . "'
                    ,'" . addslashes($OrderId) . "')";
        $readConnection->query($query);


        $this->emptyCookieSession();
        //  $this->_getCheckout()->createOrders();
        $this->_getState()->setActiveStep(
          Mage_Checkout_Model_Type_Multishipping_State::STEP_SUCCESS
        );
        $this->_getState()->setCompleteStep(
          Mage_Checkout_Model_Type_Multishipping_State::STEP_OVERVIEW
        );
        $this->_getCheckout()->getCheckoutSession()->clear();
        $this->_getCheckout()->getCheckoutSession()->setDisplaySuccess(TRUE);
        Mage_Core_Controller_Varien_Action::_redirect('checkout/multishipping/success', ['_secure' => FALSE]);


      }
      elseif (isset($info["http_code"]) && $info["http_code"] == 307) {
        $retour = json_decode($result, 1);
        if (is_array($retour["checkEnrollment"])) {
          Mage::getModel('core/cookie')
            ->set('retour3DS', json_encode($retour["checkEnrollment"]));
          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('saveCard', Mage::getSingleton('core/session')
              ->getData('saveCard'));
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('orderId', $quote->getId());
          if (isset($retour["otp"]) && $retour["otp"]) {
            Mage::getModel('core/cookie')->set('otp', 1);

          }
          if (isset($retour["cvc"]) && $retour["cvc"]) {
            Mage::getModel('core/cookie')->set('cvc', 1);

          }
          $url = Mage::getUrl('custompaymentmethod/payment/threedsiframemultishipping', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);


          exit();

        }
        if (isset($retour["otp"]) && $retour["otp"]) {

          if (isset($retour["cvc"]) && $retour["cvc"]) {
            Mage::getModel('core/cookie')->set('cvc', 1);

          }

          $otp['customerId'] = $customerid;
          $otp['provider'] = $config["provider"];
          $otp['currency'] = $detail_com["store_currency_code"];
          $otp['amount'] = $total;
          $otpfields = isset($otp) ? http_build_query($otp) : FALSE;
          $curl = curl_init();
          curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
          curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
          curl_setopt($curl, CURLOPT_POST, 1);
          curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
          curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
          $result = curl_exec($curl);
          $info = curl_getinfo($curl);
          $retour = json_decode($result, 1);
          curl_close($curl);

          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('orderId', $quote->getId());
          Mage::getModel('core/cookie')
            ->set('otp', 1);
          Mage::getModel('core/cookie')
            ->set('saveCard', Mage::getSingleton('core/session')
              ->getData('saveCard'));
          $url = Mage::getUrl('custompaymentmethod/payment/otpmultishipping', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);


          exit();


        }

        if (isset($retour["cvc"]) && $retour["cvc"]) {
          Mage::getModel('core/cookie')->set('cardId', $cardId);
          Mage::getModel('core/cookie')
            ->set('customerValidationValue', $customerValidationValue);
          Mage::getModel('core/cookie')
            ->set('transaction', json_encode($trans));
          Mage::getModel('core/cookie')
            ->set('orderId', $quote->getId());
          Mage::getModel('core/cookie')
            ->set('saveCard', Tools::getValue("saveCard"));
          $url = Mage::getUrl('custompaymentmethod/payment/cvcmultishipping', ['_secure' => FALSE]);
          Mage::register('redirect_url', $url);
          return $this->_redirectUrl($url);
          exit();
        }

      }
      else {

        $this->emptyCookieSession();
        Mage::helper('checkout')
          ->sendPaymentFailedEmail($this->_getCheckout()
            ->getQuote(), '', 'multi-shipping');
        $this->_getCheckoutSession()->addError($this->__('Order place error.'));

        return $this->_redirectUrl($url_error);

      }


      if (isset($retour["errors"])) {  // Error message
        $this->emptyCookieSession();
        Mage::helper('checkout')
          ->sendPaymentFailedEmail($this->_getCheckout()
            ->getQuote(), '', 'multi-shipping');
        $this->_getCheckoutSession()->addError($this->__('Order place error.'));

        return $this->_redirectUrl($url_error);

      }

    }
    else {
      $this->emptyCookieSession();
      Mage::helper('checkout')
        ->sendPaymentFailedEmail($this->_getCheckout()
          ->getQuote(), '', 'multi-shipping');
      $this->_getCheckoutSession()->addError($this->__('Order place error.'));

      return $this->_redirectUrl($url_error);
    }

  }

  /**
   * Retrieve checkout session
   *
   * @return Mage_Checkout_Model_Session
   */
  protected function _getCheckoutSession() {
    return Mage::getSingleton('checkout/session');
  }

  /**
   * Retrieve checkout model
   *
   * @return Mage_Checkout_Model_Type_Multishipping
   */
  protected function _getCheckout() {
    return Mage::getSingleton('checkout/type_multishipping');
  }

  /**
   * Retrieve checkout state model
   *
   * @return Mage_Checkout_Model_Type_Multishipping_State
   */
  protected function _getState() {
    return Mage::getSingleton('checkout/type_multishipping_state');
  }

  public function errorAction() {
    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_error_centralpay',
      ['template' => 'centralpay/error.phtml']
    );

    $this->getLayout()->getBlock('content')->append($block);


    $this->renderLayout();

  }

  public function threedsiframeAction() {

    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_3ds_iframe_centralpay',
      ['template' => 'centralpay/3dsiframe.phtml']
    );

    $this->getLayout()->getBlock('content')->append($block);


    $this->renderLayout();
  }

  public function threedsiframemultishippingAction() {

    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_3ds_iframe_centralpay',
      ['template' => 'centralpay/3dsiframemultishipping.phtml']
    );

    $this->getLayout()->getBlock('content')->append($block);


    $this->renderLayout();
  }

  public function threedsAction() {

    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_3ds_centralpay',
      ['template' => 'centralpay/3ds.phtml']
    );

    $this->getLayout()->getBlock('content')->append($block);
    $this->getLayout()->unsetBlock('header');
    $this->getLayout()->unsetBlock('footer');


    $this->renderLayout();

  }

  public function otpAction() {


    $onepage = Mage::getSingleton('checkout/type_onepage');
    $session = $onepage->getCheckout();
    $lastQuoteId = $session->getLastQuoteId();


    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);


    $add = $quote->getBillingAddress()->getData();
    $add["PaRes"] = $this->getRequest()->get('PaRes');

    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_otp_centralpay',
      ['template' => 'centralpay/otp.phtml']
    )->setData('add', $add);

    $this->getLayout()->getBlock('content')->append($block);
    $this->getLayout()->unsetBlock('header');
    $this->getLayout()->unsetBlock('footer');


    $this->renderLayout();

  }

  public function cvcAction() {


    $onepage = Mage::getSingleton('checkout/type_onepage');
    $session = $onepage->getCheckout();
    $lastQuoteId = $session->getLastQuoteId();


    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);


    $add = $quote->getBillingAddress()->getData();

    $add["PaRes"] = $this->getRequest()->get('PaRes');

    $trans = json_decode(Mage::getModel('core/cookie')
      ->get('transaction'), 1);


    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $config = Mage::getStoreConfig('payment/custompaymentmethod');
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, trim($url_api) . "card/" . $trans["cardId"]);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);

    $temp = json_decode($result,1);
    $add['carte']=substr($temp["first6"],0,1).'XXX-XXXX-XXXX-'.$temp["last4"];
        $add['expirationMonth']=$temp["expirationMonth"];
        $add['expirationYear']=$temp["expirationYear"];


    //Get current layout state



    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_otp_centralpay',
      ['template' => 'centralpay/cvc.phtml']
    )->setData('add', $add);

    $this->getLayout()->getBlock('content')->append($block);
    $this->getLayout()->unsetBlock('header');
    $this->getLayout()->unsetBlock('footer');


    $this->renderLayout();

  }


  public function otpmultishippingAction() {


    $multishipping = Mage::getSingleton('checkout/type_multishipping');


    $quote = $this->_getCheckoutSession()->getQuote();


    $add = $quote->getBillingAddress()->getData();
    $add["PaRes"] = $this->getRequest()->get('PaRes');

    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_otp_centralpay',
      ['template' => 'centralpay/otpmultishipping.phtml']
    )->setData('add', $add);

    $this->getLayout()->getBlock('content')->append($block);
    $this->getLayout()->unsetBlock('header');
    $this->getLayout()->unsetBlock('footer');


    $this->renderLayout();

  }

  public function cvcmultishippingAction() {


    $multishipping = Mage::getSingleton('checkout/type_multishipping');


    $quote = $this->_getCheckoutSession()->getQuote();


    $add = $quote->getBillingAddress()->getData();
    $add["PaRes"] = $this->getRequest()->get('PaRes');

    $trans = json_decode(Mage::getModel('core/cookie')
      ->get('transaction'), 1);


    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $config = Mage::getStoreConfig('payment/custompaymentmethod');
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, trim($url_api) . "card/" . $trans["cardId"]);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);

    $temp = json_decode($result,1);
    $add['carte']=substr($temp["first6"],0,1).'XXX-XXXX-XXXX-'.$temp["last4"];
    $add['expirationMonth']=$temp["expirationMonth"];
    $add['expirationYear']=$temp["expirationYear"];



    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_otp_centralpay',
      ['template' => 'centralpay/cvcmultishipping.phtml']
    )->setData('add', $add);

    $this->getLayout()->getBlock('content')->append($block);
    $this->getLayout()->unsetBlock('header');
    $this->getLayout()->unsetBlock('footer');


    $this->renderLayout();

  }
  public function threedsmultishippingAction() {

    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_3ds_centralpay',
      ['template' => 'centralpay/3dsmultishipping.phtml']
    );

    $this->getLayout()->getBlock('content')->append($block);
    $this->getLayout()->unsetBlock('header');
    $this->getLayout()->unsetBlock('footer');


    $this->renderLayout();

  }

  public function threedsretourAction() {


    // Url erreur de paiement
    $url_error = Mage::getUrl('custompaymentmethod/payment/error', ['_secure' => FALSE]);


    $onepage = Mage::getSingleton('checkout/type_onepage');
    $session = $onepage->getCheckout();
    if (!$session->getLastSuccessQuoteId()) {
      $this->_redirect('checkout/cart');
      return;
    }

    $lastQuoteId = $session->getLastQuoteId();
    $lastOrderId = $session->getLastOrderId();


    $order = Mage::getModel('sales/order')->loadByIncrementId($lastOrderId);
    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);

    $total = intval($quote->getGrandTotal() * 100);


    $add = $quote->getBillingAddress()->getData();
    $detail_com = $quote->getData();
    //  print_r($detail_com);
    //  print_r($_REQUEST);
    //  print_r($add);
    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }

    /**
     * Si le paramétre PaRes est vide on considère une erreur de paiement
     */

    if (empty($this->getRequest()->get('PaRes'))) {

      Mage::getSingleton('core/cookie')->delete('retour3DS');
      Mage::getSingleton('core/cookie')->delete('cardId');

      //Get current layout state
      $this->loadLayout();

      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('url', $url_error);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();

    }

    /**
     * Récupération des données en session et des valeurs postées
     */
    $session = json_decode(Mage::getSingleton('core/cookie')
      ->get('retour3DS'), 1);


    /*
     * Récupération du customer id
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');
    $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_customer') . ' WHERE cmsCustomerId=' . intval($detail_com["customer_id"]);

    $results = $readConnection->fetchAll($query);
    $customerid = $results[0]["customerId"];

    $trans['currency'] = $detail_com["store_currency_code"];
    $trans['amount'] = $total;
    $trans['customerId'] = $customerid;
    $trans['cardId'] = Mage::getModel('core/cookie')->get('cardId');
    $trans['customerValidationValue'] = $this->context->cookie->customerValidationValue;
    $trans['merchantTransactionId'] = $quote->getId();
    $trans['pointOfSaleId'] = $config["point_of_sale"];
    $trans['endUserIp'] = $adresse_ip;
    $trans["3ds"] = [
      "enrollmentId" => $session["enrollmentId"],
      "paRes" => $this->getRequest()->get('PaRes'),
    ];
    Mage::getModel('core/cookie')
      ->set('transaction', $trans);
//echo Mage::getModel('core/cookie')
//  ->set('otp');
    if (Mage::getModel('core/cookie')
        ->get('otp') == 1
    ) {

      $otp['customerId'] = $customerid;
      $otp['provider'] = $config["provider"];
      $otp['currency'] = $detail_com["store_currency_code"];
      $otp['amount'] = $total;
      $otpfields = isset($otp) ? http_build_query($otp) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);

      Mage::getModel('core/cookie')
        ->set('PaRes', $this->getRequest()->get('PaRes'));

      /*Mage::getModel('core/cookie')
        ->set('otp', 1);*/

      $url = Mage::getUrl('custompaymentmethod/payment/otp', ['_secure' => FALSE]);
      $data["url"] = $url;
      $data["PaRes"] = $this->getRequest()->get('PaRes');


      $this->loadLayout();
      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('data', $data);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();
      /*
      Mage::register('redirect_url', $url);
     return  $this->_redirectUrl($url);*/
      //    exit();


    }
    elseif (Mage::getModel('core/cookie')
        ->get('cvc') == 1
    ) {
      $url = Mage::getUrl('custompaymentmethod/payment/cvc', ['_secure' => FALSE]);
      $data["url"] = $url;
      $data["PaRes"] = $this->getRequest()->get('PaRes');


      $this->loadLayout();
      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('data', $data);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();


    }else {


      // var_dump($trans);
      $transfields = isset($trans) ? http_build_query($trans) : FALSE;
      // var_dump($transfields);
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);
      //var_dump($info);
      //var_dump($retour);
      /**
       * Vérification de l'état de la transaction
       */

      if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
        $order = Mage::getModel('sales/order');


        $order->loadByIncrementId(Mage::getSingleton('core/cookie')
          ->get('orderId'));
        $OrderId = $order->getId();
        $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
          'Payment success'
        );

        $payment = $order->getPayment();
        $payment->setTransactionId($retour["transactionId"])
          ->setCurrencyCode($order->getBaseCurrencyCode())
          ->setPreparedMessage('Payment by Centralpay')
          //  ->setParentTransactionId($retour["transactionId"])
          ->setShouldCloseParentTransaction(TRUE)
          ->setIsTransactionClosed(1)
          ->registerCaptureNotification($total / 100);
        $order->save();

        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        $table = $resource->getTableName('centralpay_payment_card');
        $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes(Mage::getModel('core/cookie')
            ->get('cardId')) . "'
                    ,'" . addslashes($OrderId) . "')";
        $readConnection->query($query);

        $url_redirect = Mage::getUrl('checkout/onepage/success', ['_secure' => FALSE]);


      }
      else {
        $url_redirect = $url_error;
      }

      $this->emptyCookieSession();

      //Get current layout state
      $this->loadLayout();
      $data["url"] = $url_redirect;
      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('data', $data);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();

    }
  }


  public function otpretourAction() {


    /**
     * Récupération des données en session et des valeurs postées
     */
    $session = json_decode(Mage::getSingleton('core/cookie')
      ->get('retour3DS'), 1);


    /*
     * Récupération du customer id
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');


    // Url erreur de paiement
    $url_error = Mage::getUrl('custompaymentmethod/payment/error', ['_secure' => FALSE]);


    $onepage = Mage::getSingleton('checkout/type_onepage');
    $session = $onepage->getCheckout();
    if (!$session->getLastSuccessQuoteId()) {
      return $this->_redirect('checkout/cart');

    }

    $lastQuoteId = $session->getLastQuoteId();
    $lastOrderId = $session->getLastOrderId();


    $order = Mage::getModel('sales/order')->loadByIncrementId($lastOrderId);
    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);

    $total = intval($quote->getGrandTotal() * 100);


    $add = $quote->getBillingAddress()->getData();
    $detail_com = $quote->getData();
    //  print_r($detail_com);
    //  print_r($_REQUEST);
    //  print_r($add);
    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }
    /**
     * Récupération des données de la transaction
     */
    $trans = json_decode(Mage::getModel('core/cookie')
      ->get('transaction'), 1);
    $retour3ds = json_decode(Mage::getModel('core/cookie')
      ->get('retour3DS'), 1);

    if (is_array($retour3ds) && isset($retour3ds["enrollmentId"]) && isset($retour3ds["enrollmentId"])) {

      $trans["3ds"] = [
        "enrollmentId" => $retour3ds["enrollmentId"],
        "paRes" => $this->getRequest()->getPost('PaRes'),
      ];
    }

    $trans['otp'] = $this->getRequest()->getPost('otp');


    /**
     * Si on doit demander le cvc on redirige vers cvc
     */
    if(Mage::getModel('core/cookie')
        ->get('cvc')==1){

      Mage::getModel('core/cookie')
        ->set('transaction', json_encode($trans));
      $url = Mage::getUrl('custompaymentmethod/payment/cvc', ['_secure' => FALSE]);
      Mage::register('redirect_url', $url);
      return $this->_redirectUrl($url);
      exit();

    }




    $transfields = isset($trans) ? http_build_query($trans) : FALSE;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);
    $retour = json_decode($result, 1);
    curl_close($curl);
    //  exit();
    /**
     * Vérification de l'état de la transaction
     */

    if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
      $order = Mage::getModel('sales/order');


      $order->loadByIncrementId(Mage::getSingleton('core/cookie')
        ->get('orderId'));
      $OrderId = $order->getId();
      // echo $OrderId;
      $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
        'Payment success'
      );

      $payment = $order->getPayment();
      $payment->setTransactionId($retour["transactionId"])
        ->setCurrencyCode($order->getBaseCurrencyCode())
        ->setPreparedMessage('Payment by Centralpay')
        //  ->setParentTransactionId($retour["transactionId"])
        ->setShouldCloseParentTransaction(TRUE)
        ->setIsTransactionClosed(1)
        ->registerCaptureNotification($total / 100);
      $order->save();

      /**
       * Enregistrement de la liaison entre le paiement et la carte centralpay
       */
      $table = $resource->getTableName('centralpay_payment_card');
      $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes(Mage::getModel('core/cookie')
          ->get('cardId')) . "'
                    ,'" . addslashes($OrderId) . "')";
      $readConnection->query($query);
      //$this->emptyCookieSession();
      // $url_redirect = Mage::getUrl('checkout/onepage/success', ['_secure' => FALSE]);
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', ['_secure' => FALSE]);

    }
    else {
      $this->emptyCookieSession();
      //$url_redirect = $url_error;
      Mage_Core_Controller_Varien_Action::_redirect('custompaymentmethod/payment/error', ['_secure' => FALSE]);
    }


    //  return $this->_redirect($url_redirect);

    /*
    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_retour_cp_centralpay',
      ['template' => 'centralpay/3dsretour.phtml']
    )->setData('url', $url_redirect);

    $this->getLayout()->getBlock('content')->append($block);


    $this->renderLayout();*/
  }

  public function cvcretourAction() {


    /**
     * Récupération des données en session et des valeurs postées
     */
    $session = json_decode(Mage::getSingleton('core/cookie')
      ->get('retour3DS'), 1);


    /*
     * Récupération du customer id
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');


    // Url erreur de paiement
    $url_error = Mage::getUrl('custompaymentmethod/payment/error', ['_secure' => FALSE]);


    $onepage = Mage::getSingleton('checkout/type_onepage');
    $session = $onepage->getCheckout();
    if (!$session->getLastSuccessQuoteId()) {
      return $this->_redirect('checkout/cart');

    }

    $lastQuoteId = $session->getLastQuoteId();
    $lastOrderId = $session->getLastOrderId();


    $order = Mage::getModel('sales/order')->loadByIncrementId($lastOrderId);
    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);

    $total = intval($quote->getGrandTotal() * 100);


    $add = $quote->getBillingAddress()->getData();
    $detail_com = $quote->getData();
    //  print_r($detail_com);
    //  print_r($_REQUEST);
    //  print_r($add);
    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }
    /**
     * Récupération des données de la transaction
     */
    $trans = json_decode(Mage::getModel('core/cookie')
      ->get('transaction'), 1);



    $retour3ds = json_decode(Mage::getModel('core/cookie')
      ->get('retour3DS'), 1);

    if (is_array($retour3ds) && isset($retour3ds["enrollmentId"]) && isset($retour3ds["enrollmentId"])) {

      $trans["3ds"] = [
        "enrollmentId" => $retour3ds["enrollmentId"],
        "paRes" => $this->getRequest()->getPost('PaRes'),
      ];
    }

    $trans['cvcValidation'] = $this->getRequest()->getPost('cvc');

    $transfields = isset($trans) ? http_build_query($trans) : FALSE;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);
    $retour = json_decode($result, 1);
    curl_close($curl);
    //  exit();
    /**
     * Vérification de l'état de la transaction
     */

    if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
      $order = Mage::getModel('sales/order');


      $order->loadByIncrementId(Mage::getSingleton('core/cookie')
        ->get('orderId'));
      $OrderId = $order->getId();
      // echo $OrderId;
      $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
        'Payment success'
      );

      $payment = $order->getPayment();
      $payment->setTransactionId($retour["transactionId"])
        ->setCurrencyCode($order->getBaseCurrencyCode())
        ->setPreparedMessage('Payment by Centralpay')
        //  ->setParentTransactionId($retour["transactionId"])
        ->setShouldCloseParentTransaction(TRUE)
        ->setIsTransactionClosed(1)
        ->registerCaptureNotification($total / 100);
      $order->save();

      /**
       * Enregistrement de la liaison entre le paiement et la carte centralpay
       */
      $table = $resource->getTableName('centralpay_payment_card');
      $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes(Mage::getModel('core/cookie')
          ->get('cardId')) . "'
                    ,'" . addslashes($OrderId) . "')";
      $readConnection->query($query);
      //$this->emptyCookieSession();
      // $url_redirect = Mage::getUrl('checkout/onepage/success', ['_secure' => FALSE]);
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', ['_secure' => FALSE]);

    }
    else {
      $this->emptyCookieSession();
      //$url_redirect = $url_error;
      Mage_Core_Controller_Varien_Action::_redirect('custompaymentmethod/payment/error', ['_secure' => FALSE]);
    }


    //  return $this->_redirect($url_redirect);

    /*
    //Get current layout state
    $this->loadLayout();

    $block = $this->getLayout()->createBlock(
      'Mage_Core_Block_Template',
      'block_retour_cp_centralpay',
      ['template' => 'centralpay/3dsretour.phtml']
    )->setData('url', $url_redirect);

    $this->getLayout()->getBlock('content')->append($block);


    $this->renderLayout();*/
  }

  public function cvcretourmultishippingAction() {


    /**
     * Récupération des données en session et des valeurs postées
     */
    $session = json_decode(Mage::getSingleton('core/cookie')
      ->get('retour3DS'), 1);


    /*
     * Récupération du customer id
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');


    $quote = $this->_getCheckoutSession()->getQuote();


    $total = intval($quote->getGrandTotal() * 100);

    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }
    /**
     * Récupération des données de la transaction
     */
    $trans = json_decode(Mage::getModel('core/cookie')
      ->get('transaction'), 1);
    $retour3ds = json_decode(Mage::getModel('core/cookie')
      ->get('retour3DS'), 1);

    if (is_array($retour3ds) && isset($retour3ds["enrollmentId"]) && isset($retour3ds["enrollmentId"])) {

      $trans["3ds"] = [
        "enrollmentId" => $retour3ds["enrollmentId"],
        "paRes" => $this->getRequest()->getPost('PaRes'),
      ];
    }

    $trans['cvcValidation'] = $this->getRequest()->getPost('cvc');


    /**
     * Si on doit demander le cvc on redirige vers cvc
     */
    if(Mage::getModel('core/cookie')
        ->get('cvc')==1){

      Mage::getModel('core/cookie')
        ->set('transaction', json_encode($trans));
      $url = Mage::getUrl('custompaymentmethod/payment/cvcmultishipping', ['_secure' => FALSE]);
      Mage::register('redirect_url', $url);
      return $this->_redirectUrl($url);
      exit();

    }


    $transfields = isset($trans) ? http_build_query($trans) : FALSE;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);
    $retour = json_decode($result, 1);
    curl_close($curl);
    //  exit();
    /**
     * Vérification de l'état de la transaction
     */

    if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
      $this->_getCheckout()->createOrders();
      //  var_dump($this->_getCheckout()->getOrderIds()).'***';

      if (is_array($this->_getCheckout()->getOrderIds())) {
        foreach ($this->_getCheckout()->getOrderIds() as $IdOrder) {


          $order = Mage::getModel('sales/order')->load($IdOrder);
          // $order->loadByIncrementId($IdOrder);
          $OrderId = $order->getId();
          $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
            'Payment success'
          );

          $payment = $order->getPayment();
          $payment->setTransactionId($retour["transactionId"])
            ->setCurrencyCode($order->getBaseCurrencyCode())
            ->setPreparedMessage('Payment by Centralpay')
            //  ->setParentTransactionId($retour["transactionId"])
            ->setShouldCloseParentTransaction(TRUE)
            ->setIsTransactionClosed(1)
            ->registerCaptureNotification($total / 100);
          $order->save();


        }

      }


      /**
       * Enregistrement de la liaison entre le paiement et la carte centralpay
       */
      $table = $resource->getTableName('centralpay_payment_card');
      $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes(Mage::getModel('core/cookie')
          ->get('cardId')) . "'
                    ,'" . addslashes($OrderId) . "')";
      $readConnection->query($query);


      $this->emptyCookieSession();
      //  $this->_getCheckout()->createOrders();
      $this->_getState()->setActiveStep(
        Mage_Checkout_Model_Type_Multishipping_State::STEP_SUCCESS
      );
      $this->_getState()->setCompleteStep(
        Mage_Checkout_Model_Type_Multishipping_State::STEP_OVERVIEW
      );
      $this->_getCheckout()->getCheckoutSession()->clear();
      $this->_getCheckout()->getCheckoutSession()->setDisplaySuccess(TRUE);

      //$url_redirect = Mage::getUrl('checkout/multishipping/success', ['_secure' => FALSE]);

      Mage_Core_Controller_Varien_Action::_redirect('checkout/multishipping/success', ['_secure' => FALSE]);

    }
    else {
      $this->emptyCookieSession();
      //$url_redirect = $url_error;
      Mage_Core_Controller_Varien_Action::_redirect('custompaymentmethod/payment/error', ['_secure' => FALSE]);
    }


  }
  public function otpretourmultishippingAction() {


    /**
     * Récupération des données en session et des valeurs postées
     */
    $session = json_decode(Mage::getSingleton('core/cookie')
      ->get('retour3DS'), 1);


    /*
     * Récupération du customer id
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');


    $quote = $this->_getCheckoutSession()->getQuote();


    $total = intval($quote->getGrandTotal() * 100);

    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }
    /**
     * Récupération des données de la transaction
     */
    $trans = json_decode(Mage::getModel('core/cookie')
      ->get('transaction'), 1);
    $retour3ds = json_decode(Mage::getModel('core/cookie')
      ->get('retour3DS'), 1);

    if (is_array($retour3ds) && isset($retour3ds["enrollmentId"]) && isset($retour3ds["enrollmentId"])) {

      $trans["3ds"] = [
        "enrollmentId" => $retour3ds["enrollmentId"],
        "paRes" => $this->getRequest()->getPost('PaRes'),
      ];
    }

    $trans['customerValidationValue'] = $this->getRequest()->getPost('otp');


    /**
     * Si on doit demander le cvc on redirige vers cvc
     */
    if(Mage::getModel('core/cookie')
        ->get('cvc')==1){

      Mage::getModel('core/cookie')
        ->set('transaction', json_encode($trans));
      $url = Mage::getUrl('custompaymentmethod/payment/cvcmultishipping', ['_secure' => FALSE]);
      Mage::register('redirect_url', $url);
      return $this->_redirectUrl($url);
      exit();

    }


    $transfields = isset($trans) ? http_build_query($trans) : FALSE;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);
    $retour = json_decode($result, 1);
    curl_close($curl);
    //  exit();
    /**
     * Vérification de l'état de la transaction
     */

    if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
      $this->_getCheckout()->createOrders();
      //  var_dump($this->_getCheckout()->getOrderIds()).'***';

      if (is_array($this->_getCheckout()->getOrderIds())) {
        foreach ($this->_getCheckout()->getOrderIds() as $IdOrder) {


          $order = Mage::getModel('sales/order')->load($IdOrder);
          // $order->loadByIncrementId($IdOrder);
          $OrderId = $order->getId();
          $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
            'Payment success'
          );

          $payment = $order->getPayment();
          $payment->setTransactionId($retour["transactionId"])
            ->setCurrencyCode($order->getBaseCurrencyCode())
            ->setPreparedMessage('Payment by Centralpay')
            //  ->setParentTransactionId($retour["transactionId"])
            ->setShouldCloseParentTransaction(TRUE)
            ->setIsTransactionClosed(1)
            ->registerCaptureNotification($total / 100);
          $order->save();


        }

      }


      /**
       * Enregistrement de la liaison entre le paiement et la carte centralpay
       */
      $table = $resource->getTableName('centralpay_payment_card');
      $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes(Mage::getModel('core/cookie')
          ->get('cardId')) . "'
                    ,'" . addslashes($OrderId) . "')";
      $readConnection->query($query);


      $this->emptyCookieSession();
      //  $this->_getCheckout()->createOrders();
      $this->_getState()->setActiveStep(
        Mage_Checkout_Model_Type_Multishipping_State::STEP_SUCCESS
      );
      $this->_getState()->setCompleteStep(
        Mage_Checkout_Model_Type_Multishipping_State::STEP_OVERVIEW
      );
      $this->_getCheckout()->getCheckoutSession()->clear();
      $this->_getCheckout()->getCheckoutSession()->setDisplaySuccess(TRUE);

      //$url_redirect = Mage::getUrl('checkout/multishipping/success', ['_secure' => FALSE]);

      Mage_Core_Controller_Varien_Action::_redirect('checkout/multishipping/success', ['_secure' => FALSE]);

    }
    else {
      $this->emptyCookieSession();
      //$url_redirect = $url_error;
      Mage_Core_Controller_Varien_Action::_redirect('custompaymentmethod/payment/error', ['_secure' => FALSE]);
    }


  }

  public function threedsretourmultishippingAction() {


    // Url erreur de paiement
    $url_error = Mage::getUrl('custompaymentmethod/payment/error', ['_secure' => FALSE]);


    $multishipping = Mage::getSingleton('checkout/type_multishipping');


    $lastQuoteId = Mage::getSingleton('checkout/session')->getLastQuoteId();
    $lastOrderId = $multishipping->getLastOrderId();


    $order = Mage::getModel('sales/order')->loadByIncrementId($lastOrderId);
    $quote = $this->_getCheckoutSession()->getQuote();

    $total = intval($quote->getGrandTotal() * 100);


    $detail_com = $quote->getData();

    $config = Mage::getStoreConfig('payment/custompaymentmethod');

    if ($config["test_mode"] == 1) {
      $url_api = API_TEST;
    }
    else {
      $url_api = API;
    }
    $card = (Mage::getSingleton('core/session')->getData('card'));
    $customerValidationValue = $card["cvc"];

    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = $config["login"] . ":" . $config["password"];

    /**
     * ADRESSE IP DU CLIENT
     */
    if ($config["test_mode"] == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = $config["ip_test"];
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }

    /**
     * Si le paramétre PaRes est vide on considère une erreur de paiement
     */

    if (empty($this->getRequest()->get('PaRes'))) {

      Mage::getSingleton('core/cookie')->delete('retour3DS');
      Mage::getSingleton('core/cookie')->delete('cardId');

      //Get current layout state
      $this->loadLayout();

      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('url', $url_error);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();

    }

    /**
     * Récupération des données en session et des valeurs postées
     */
    $session = json_decode(Mage::getSingleton('core/cookie')
      ->get('retour3DS'), 1);


    /*
     * Récupération du customer id
     */
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');
    $query = 'SELECT * FROM ' . $resource->getTableName('centralpay_customer') . ' WHERE cmsCustomerId=' . intval($detail_com["customer_id"]);

    $results = $readConnection->fetchAll($query);
    $customerid = $results[0]["customerId"];

    $trans['currency'] = $detail_com["store_currency_code"];
    $trans['amount'] = $total;
    $trans['customerId'] = $customerid;
    $trans['cardId'] = Mage::getModel('core/cookie')->get('cardId');
    $trans['customerValidationValue'] = $this->context->cookie->customerValidationValue;
    $trans['merchantTransactionId'] = $quote->getId();
    $trans['pointOfSaleId'] = $config["point_of_sale"];
    $trans['endUserIp'] = $adresse_ip;
    $trans["3ds"] = [
      "enrollmentId" => $session["enrollmentId"],
      "paRes" => $this->getRequest()->get('PaRes'),
    ];

    Mage::getModel('core/cookie')
      ->set('transaction', $trans);

    if (Mage::getModel('core/cookie')
        ->get('otp') == 1
    ) {

      $otp['customerId'] = $customerid;
      $otp['provider'] = $config["provider"];
      $otp['currency'] = $detail_com["store_currency_code"];
      $otp['amount'] = $total;
      $otpfields = isset($otp) ? http_build_query($otp) : FALSE;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);

      Mage::getModel('core/cookie')
        ->set('PaRes', $this->getRequest()->get('PaRes'));

      Mage::getModel('core/cookie')
        ->set('otp', 1);

      $url = Mage::getUrl('custompaymentmethod/payment/otpmultishipping', ['_secure' => FALSE]);
      $data["url"] = $url;
      $data["PaRes"] = $this->getRequest()->get('PaRes');


      $this->loadLayout();
      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('data', $data);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();
      /*
      Mage::register('redirect_url', $url);
     return  $this->_redirectUrl($url);*/
      //    exit();


    }elseif (Mage::getModel('core/cookie')
        ->get('cvc') == 1
    ) {
      $url = Mage::getUrl('custompaymentmethod/payment/cvcmultishipping', ['_secure' => FALSE]);
      $data["url"] = $url;
      $data["PaRes"] = $this->getRequest()->get('PaRes');


      $this->loadLayout();
      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('data', $data);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();


    }
    else {
      // var_dump($trans);
      $transfields = isset($trans) ? http_build_query($trans) : FALSE;
      // var_dump($transfields);
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);
      //var_dump($info);
      //var_dump($retour);
      /**
       * Vérification de l'état de la transaction
       */

      if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
        $this->_getCheckout()->createOrders();

        if (is_array($this->_getCheckout()->getOrderIds())) {
          foreach ($this->_getCheckout()->getOrderIds() as $IdOrder) {


            $order = Mage::getModel('sales/order')->load($IdOrder);
            $OrderId = $order->getId();
            $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW,
              'Payment success'
            );

            $payment = $order->getPayment();
            $payment->setTransactionId($retour["transactionId"])
              ->setCurrencyCode($order->getBaseCurrencyCode())
              ->setPreparedMessage('Payment by Centralpay')
              //  ->setParentTransactionId($retour["transactionId"])
              ->setShouldCloseParentTransaction(TRUE)
              ->setIsTransactionClosed(1)
              ->registerCaptureNotification($total / 100);
            $order->save();


          }

        }


        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        $table = $resource->getTableName('centralpay_payment_card');
        $query = "INSERT INTO {$table} (`cardId`,`cmsPaymentId`)
                    VALUES ('" . addslashes(Mage::getModel('core/cookie')
            ->get('cardId')) . "'
                    ,'" . addslashes($OrderId) . "')";
        $readConnection->query($query);


        $this->emptyCookieSession();
        //  $this->_getCheckout()->createOrders();
        $this->_getState()->setActiveStep(
          Mage_Checkout_Model_Type_Multishipping_State::STEP_SUCCESS
        );
        $this->_getState()->setCompleteStep(
          Mage_Checkout_Model_Type_Multishipping_State::STEP_OVERVIEW
        );
        $this->_getCheckout()->getCheckoutSession()->clear();
        $this->_getCheckout()->getCheckoutSession()->setDisplaySuccess(TRUE);

        $url_redirect = Mage::getUrl('checkout/multishipping/success', ['_secure' => FALSE]);


      }
      else {

        Mage::helper('checkout')
          ->sendPaymentFailedEmail($this->_getCheckout()
            ->getQuote(), '', 'multi-shipping');
        $this->_getCheckoutSession()->addError($this->__('Order place error.'));
        $url_redirect = Mage::getUrl('checkout/multishipping/billing', ['_secure' => FALSE]);
      }

      $this->emptyCookieSession();

      //Get current layout state
      $this->loadLayout();

      $block = $this->getLayout()->createBlock(
        'Mage_Core_Block_Template',
        'block_retour_cp_centralpay',
        ['template' => 'centralpay/3dsretour.phtml']
      )->setData('url', $url_redirect);

      $this->getLayout()->getBlock('content')->append($block);


      $this->renderLayout();
    }

  }

  public function responseAction() {
    if ($this->getRequest()->get("flag") == "1" && $this->getRequest()
        ->get("orderId")
    ) {
      $orderId = $this->getRequest()->get("orderId");
      $order = Mage::getModel('sales/order')->loadByIncrementId($orderId);
      $order->setState(Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, TRUE, 'Payment Success.');
      $order->save();

      Mage::getSingleton('checkout/session')->unsQuoteId();
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', ['_secure' => FALSE]);
    }
    else {
      Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/error', ['_secure' => FALSE]);
    }
  }
}