<?php
$installer = $this;
$installer->startSetup();
$installer->run("

DROP TABLE IF EXISTS `{$this->getTable('centralpay_card')}`;
CREATE TABLE IF NOT EXISTS `{$this->getTable('centralpay_card')}` (
  `cardId` varchar(255) NOT NULL,
  `customerId` varchar(255) NOT NULL,
  `commercialBrand` varchar(45) DEFAULT NULL,
  `first6` varchar(6) DEFAULT NULL,
  `last4` varchar(4) DEFAULT NULL,
  `default` tinyint(1) DEFAULT NULL,
  `creationDate` datetime DEFAULT NULL,
  `cardTokenId` varchar(255) DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `expirationYear` int(11) DEFAULT NULL,
  `expirationMonth` int(11) DEFAULT NULL,
  PRIMARY KEY (`cardId`),
  KEY `fk_centralpay_card_centralpay_customer_idx` (`customerId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

       DROP TABLE IF EXISTS `{$this->getTable('centralpay_customer')}`;
CREATE TABLE IF NOT EXISTS `{$this->getTable('centralpay_customer')}` (
  `customerId` varchar(255) NOT NULL,
  `cmsCustomerId` varchar(255) NOT NULL,
  `creationDate` datetime NOT NULL,
  PRIMARY KEY (`customerId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `{$this->getTable('centralpay_payment_card')}`;
CREATE TABLE IF NOT EXISTS `{$this->getTable('centralpay_payment_card')}` (
  `cardId` varchar(255) NOT NULL,
  `cmsPaymentId` varchar(255) DEFAULT NULL,
  KEY `fk_centralpay_payment_card_centralpay_card1_idx` (`cardId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


");
$installer->endSetup();