<?php
DEFINE('JS_TEST', 'js/token.js');
DEFINE('JS', 'js/token-prod.js');
DEFINE('API_TEST', 'https://test-api.centralpay.net/v2/rest/');
DEFINE('API', 'https://api.centralpay.net/v2/rest/');

class Centralpay_Custompaymentmethod_CustomerController extends Mage_Core_Controller_Front_Action
{

   const CENTRALPAY_CARD_TABLE ='centralpay_card';

    /**
     * Checking if user is logged in or not
     * If not logged in then redirect to customer login
     */
    public function preDispatch()
    {
        parent::preDispatch();

        if (!Mage::getSingleton('customer/session')->authenticate($this)) {
            $this->setFlag('', 'no-dispatch', true);

            // adding message in customer login page
            Mage::getSingleton('core/session')
                ->addSuccess(Mage::helper('custompaymentmethod')->__('Please sign in or create a new account'));
        }
    }


    public function viewAction()
    {

        $customerData = Mage::getSingleton('customer/session')->getCustomer();
        /**
         * Suppression d'une carte
         */
        if (Mage::app()->getRequest()->getParam('action') == 'delete') {
            $resource = Mage::getSingleton('core/resource');
            $readConnection = $resource->getConnection('core_read');
            //on vérifie si la carte est bien une carte de l'utilisateur actuel
            $sql = 'SELECT * FROM ' . $resource->getTableName(self::CENTRALPAY_CARD_TABLE) . ' as A 
            INNER JOIN ' . $resource->getTableName('centralpay_customer') . ' as B  ON A.customerId=B.customerId  
            WHERE A.deleted is NULL AND B.cmsCustomerId=' . intval($customerData->getId()) . ' AND A.cardId=\'' . addslashes(Mage::app()->getRequest()->getParam('card')) . '\' ORDER BY A.expirationYear DESC,A.expirationMonth DESC';

            $results = $readConnection->fetchAll($sql);


            if (isset($results[0])) {
                $query = 'DELETE FROM ' . $resource->getTableName(self::CENTRALPAY_CARD_TABLE) . ' WHERE cardId=\'' . addslashes(Mage::app()->getRequest()->getParam('card')) . '\'';
                $readConnection->query($query);
            }
        }
        /**
         * Mettre une carte par défaut
         */
        if (Mage::app()->getRequest()->getParam('action') == 'default') {
            $resource = Mage::getSingleton('core/resource');
            $readConnection = $resource->getConnection('core_read');
            //on vérifie si la carte est bien une carte de l'utilisateur actuel
            $sql = 'SELECT * FROM ' . $resource->getTableName(self::CENTRALPAY_CARD_TABLE) . ' as A 
            INNER JOIN ' . $resource->getTableName('centralpay_customer') . ' as B  ON A.customerId=B.customerId  
            WHERE A.deleted is NULL AND B.cmsCustomerId=' . intval($customerData->getId()) . ' AND A.cardId=\'' . addslashes(Mage::app()->getRequest()->getParam('card')) . '\' ORDER BY A.expirationYear DESC,A.expirationMonth DESC';

            $results = $readConnection->fetchAll($sql);


            if (isset($results[0])) {

                $query = 'UPDATE ' . $resource->getTableName(self::CENTRALPAY_CARD_TABLE) . ' SET `default`=0 WHERE customerId=\'' . addslashes($results[0]["customerId"]) . '\'';

                $readConnection->query($query);

                $query = 'UPDATE ' . $resource->getTableName(self::CENTRALPAY_CARD_TABLE) . ' SET `default`=1 WHERE cardId=\'' . addslashes(Mage::app()->getRequest()->getParam('card')) . '\'';

                $readConnection->query($query);
            }
        }


        $this->loadLayout();
        $this->getLayout()->getBlock('head')->setTitle($this->__('My cards'));

        $block = $this->getLayout()->createBlock(
            'Mage_Core_Block_Template',
            'my_cards',
            array('template' => 'centralpay/customer/view.phtml')
        );

        $this->getLayout()->getBlock('content')->append($block);

        $this->renderLayout();

    }

}